	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

.code
	include ..\Bin\KiteH.inc
	include ..\Build\Bin\Builder.inc
	include ..\Build\Bin\Kitb.inc
	
%PSHEAP macro R
	assume fs:nothing
	mov R,fs:[TEB.Peb]
	mov R,PEB.ProcessHeap[R]
endm

MmAlloc proc S1ze:ULONG
	%PSHEAP Eax
	push S1ze
	push HEAP_ZERO_MEMORY
	push eax
	Call RtlAllocateHeap
	ret
MmAlloc endp

MmFree proc Base:PVOID
	%PSHEAP Eax
	push Base
	push 0
	push eax
	Call RtlFreeHeap
	ret
MmFree endp

MmAllocForBuild proc S1ze:ULONG
Local Base:PVOID
	mov Base,NULL
	lea ecx,S1ze
	lea edx,Base
	push PAGE_READWRITE
	push MEM_COMMIT
	push ecx
	push 0
	push edx
	push NtCurrentProcess
	Call ZwAllocateVirtualMemory
	.if !Eax
		mov eax,Base
	.else
		xor eax,eax
	.endif
	ret
MmAllocForBuild endp

MmProtectForBuild proc Base:PVOID, S1ze:ULONG
	lea eax,Base
	lea ecx,S1ze
	push eax
	push PAGE_EXECUTE_READ
	push ecx
	push eax
	push NtCurrentProcess
	Call ZwProtectVirtualMemory
	test eax,eax
	setz al
	movzx eax,al
	ret
MmProtectForBuild endp

Testp proc
L0:
	jmp near ptr $+5
	jb near ptr L4
	jne near ptr L3
	nop
L2:
	jz near ptr L1
	nop
L1:
	jc near ptr L2
L3:
	nop
	jb near ptr L0
L4:
	jmp near ptr L5
	nop
L5:
	Call L0
	Call L2
	Loop L0
	
	ret
Testp endp
	
; +
;
KiBuild proc uses ebx esi
Local Store:PGPSTORE
	push 0
	push -1
	push offset Testp
	push 32
	push MmFree
	push MmAlloc
	%CKITE KID_KIT
	mov ebx,eax
	.if !Zero?
		push BUILD_IDLE_CLEANUP
		push MmAllocForBuild
		push MmFree
		push MmAlloc
		push ebx
		%CKITB KID_BUILD
		.if Eax
			Int 3
		.endif
	.endif
	push MmFree
	push ebx
	%CKITE KID_FREE_STORE
	ret
KiBuild endp

EP proc
	invoke KiBuild
	ret
EP endp
end EP